#****************************************************************************
#**
#**  File     :  /lua/sim/buffdefinition.lua
#**
#**  Copyright  2008 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

import('/lua/sim/AdjacencyBuffs.lua')
import('/lua/sim/CheatBuffs.lua') # Buffs for AI Cheating
local AdjBuffFuncs = import('/lua/sim/AdjacencyBuffFunctions.lua')

##################################################################
## ADJENCY FACTORIES BUFFS - COSTBUFF
##################################################################
BuffBlueprint {
    Name = 'Tiers1_01FactoryMassBuff',
    DisplayName = 'T1Factory01Mass',
    BuffType = 'MASSBUILDBONUS',
                    Stacks = 'REPLACE',
    Duration = -1,
    #EntityCategory = 'UEB010101',
    BuffCheckFunction = AdjBuffFuncs.MassBuildBuffCheck,
    OnBuffAffect = AdjBuffFuncs.MassBuildBuffAffect,
    OnBuffRemove = AdjBuffFuncs.MassBuildBuffRemove,
    Affects = {
        MassActive = {
            Add = -0.2,
            Mult = 1.0,
        },
    },
}

BuffBlueprint {
    Name = 'Tiers1_01FactoryBuff',
    DisplayName = 'T1Factory01',
    BuffType = 'ENERGYBUILDBONUS',
                    Stacks = 'REPLACE',
    Duration = -1,
    #EntityCategory = 'STRUCTURE SIZE4',
    BuffCheckFunction = AdjBuffFuncs.EnergyBuildBuffCheck,
    OnBuffAffect = AdjBuffFuncs.EnergyBuildBuffAffect,
    OnBuffRemove = AdjBuffFuncs.EnergyBuildBuffRemove,
    Affects = {
        EnergyActive = {
            Add = -0.20,
            Mult = 1.0,
        },
    },
}


__moduleinfo.auto_reload = true
