#****************************************************************************
#**
#**  File     :  /cdimage/units/UAB0301/UAB0301_script.lua
#**  Author(s):  David Tomandl
#**
#**  Summary  :  Aeon Land Factory Tier 3 Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local SLandFactoryUnit = import('/lua/seraphimunits.lua').SLandFactoryUnit
local SDFUltraChromaticBeamGenerator = import('/lua/seraphimweapons.lua').SDFUltraChromaticBeamGenerator

XSB0301 = Class(SLandFactoryUnit) {


    Weapons = {
        MainGun = Class(SDFUltraChromaticBeamGenerator) {}
    },

    OnCreate = function(self)
        SLandFactoryUnit.OnCreate(self)
        local bp = self:GetBlueprint()
        self.Rotator1 = CreateRotator(self, 'Pod01', 'y', nil, 5, 0, 0)
        self.Trash:Add(self.Rotator1)
		
        self.Rotator2 = CreateRotator(self, 'Pod04', 'y', nil, 18, 0, 0)
        self.Trash:Add(self.Rotator2)				
    end,

    OnKilled = function(self, instigator, type, overkillRatio)
        self.Rotator1:SetSpeed(0)
        self.Rotator2:SetSpeed(0)
        SLandFactoryUnit.OnKilled(self, instigator, type, overkillRatio)
    end,	
	
}

TypeClass = XSB0301