#****************************************************************************
#**
#**  File     :  /units/URL010102/URL010102_script.lua
#**  Author(s):  John Comes, David Tomandl
#**
#**  Summary  :  Cybran Land Scout Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local CWalkingLandUnit = import('/lua/cybranunits.lua').CWalkingLandUnit
local Entity = import('/lua/sim/Entity.lua').Entity

URL010102 = Class(CWalkingLandUnit) {
    OnStopBeingBuilt = function(self,builder,layer)
        CWalkingLandUnit.OnStopBeingBuilt(self,builder,layer)
        #entity used for radar
        local bp = self:GetBlueprint()
		self.RadarEnt = Entity {}
        #self.Trash:Add(self.RadarEnt)
        #enable cloaking economy
        #self:SetMaintenanceConsumptionActive()
        self:SetMaintenanceConsumptionInactive()
        --self:SetScriptBit('RULEUTC_CloakToggle', true)
		self:SetScriptBit('RULEUTC_IntelToggle', true)
        self:RequestRefreshUI()
    end,

    TransformThread = function(self, land)
        if( not self.AnimManip ) then
            self.AnimManip = CreateAnimator(self)
        end
        local bp = self:GetBlueprint()

        if( land ) then
			self:SetImmobile(true)
            self.AnimManip:PlayAnim(self:GetBlueprint().Display.AnimationTransform)
            self.AnimManip:SetRate(1)
            self.IsWaiting = true
            WaitFor(self.AnimManip)
			self.IsWaiting = false
            self.Trash:Add(self.AnimManip)
			
        else
            self:SetImmobile(true)
            self.AnimManip:PlayAnim(self:GetBlueprint().Display.AnimationTransform)
            self.AnimManip:SetAnimationFraction(1)
            self.AnimManip:SetRate(-1)
            self.IsWaiting = true
            WaitFor(self.AnimManip)
			self.IsWaiting = false
            self.AnimManip = nil
            self:SetImmobile(false)
        end
    end,	
	
    OnIntelEnabled = function(self)
        CWalkingLandUnit.OnIntelEnabled(self)
		local bp = self:GetBlueprint()
		if self.OnIntelEnabled then
			self.AT1 = self:ForkThread(self.TransformThread, true)
			self:SetScriptBit('RULEUTC_CloakToggle', true)
        end	
    end,	
	
    OnIntelDisabled = function(self)
        CWalkingLandUnit.OnIntelDisabled(self)
		local bp = self:GetBlueprint()
		if self.OnIntelEnabled then
			self.AT1 = self:ForkThread(self.TransformThread, false)
			self:SetScriptBit('RULEUTC_CloakToggle', false)
        end	
    end,	
	

  	
  
}	


TypeClass = URL010102